image: "python:3.8-slim"

before_script:
  - apt-get update
  - apt-get install -y build-essential
  - pip install .[dev]

lint-flake8:
  script:
    - flake8 semantic_pandas tests

lint-pylint:
  script:
    - pylint --rcfile=.pylintrc semantic_pandas
    - pylint --rcfile=.pylintrc --disable=missing-module-docstring,missing-function-docstring,missing-class-docstring,no-self-use,too-few-public-methods tests

unittest-pytest-with-coverage:
  script:
    - coverage run --source=semantic_pandas -m pytest --junitxml=test-report.xml
    # NOTE: scripts are excluded from testing since they are volatile and experimental in nature
    # NOTE: server modules are excluded from testing since they are not the focus of this project
    #   and disproportional difficult to test
    - coverage report -m --omit="semantic_pandas/scripts/*,semantic_pandas/language_server/*"
    - coverage xml --omit="semantic_pandas/scripts/*,semantic_pandas/language_server/*" -o coverage-report.xml
  artifacts:
    reports:
      junit: test-report.xml
      cobertura: coverage-report.xml

# build-sphinx-documentation:
#   script:
#     - cd doc
#     - make SPHINXOPTS="-W" html
